extends Sprite2D

var image: Image
var image_texture: ImageTexture

var time_taken := 0.0
const ITERATIONS = 100
var iterations_left := 100


func _ready() -> void:
	image = Image.create(4096, 4096, false, Image.FORMAT_RGBAF)
	image.fill(Color.TURQUOISE)
	texture = ImageTexture.create_from_image(image)
	self.texture = texture


func _process(_delta: float) -> void:
	var time_start := Time.get_ticks_usec()
	texture.update(image)
	var time_end := Time.get_ticks_usec()
	time_taken += 0.001 * (time_end - time_start)
	iterations_left -= 1

	if iterations_left == 0:
		print("Average of 100 iterations: %.2f ms" % (time_taken / ITERATIONS))
		for i in 2:
			await get_tree().process_frame

		get_tree().quit()
